#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/utime.h>
#include <string.h>
#include <ctype.h>
#include <direct.h>

int convert(const char *name,int mode) {
	int len,len1,n,t;
	char *src,*dst;
	int f;
	struct _stat buf;
	struct utimbuf times;
	f=open(name,O_RDWR | O_BINARY);
	if (f==-1) {
		fprintf(stderr,"Could not open file %s\n",name);
		return 2;
	}
	_fstat(f,&buf);
	len=filelength(f);
	if (len>4*1024*1024) {
		fprintf(stderr,"File %s is too big and it won't be processed\n"
				"(I don't think it's a source file)\n",name);
		close(f);
		return 3;
	}
	printf("Converting %s (%i->%i)\n",name,(2-mode)*4,(1+mode)*4);
	src=(char*)malloc(len+1);
	dst=(char*)malloc(1+mode?len*4:len*2);
	if (!src || !dst) {
		fprintf(stderr,"Out of memory!\n");
		if (src) free(src);
		if (dst) free(dst);
		close(f);
		return 4;
	}
	src[0]=10;
	src++,dst++;
	read(f,src,len);
	for(n=0;n<len;n++) if (src[n]==0) {
		fprintf(stderr,"%s is not a text file (\\0 encountered)!\n",name);
		free(src-1); free(dst-1); close(f);
		return 5;
	}
	if (mode) {
		for(n=len1=-1;n<len;n++) {
			dst[len1++]=src[n];
			if (src[n]==10) if(n<len-1 && (src[n+1]==32 || src[n+1]==9)) {
				n++;
				for(t=src[n]==9?4:1;n<len-1 && (src[n+1]==32 || src[n+1]==9);n++)
					if (src[n+1]==32) t++; else t=(t+4) & (~3);
				while (t>=8) dst[len1++]=9,t-=8;
				for(;t>0;t--) dst[len1++]=32;
			}
		}
	} else {
		for(n=len1=-1;n<len;n++) {
			dst[len1++]=src[n];
			if (src[n]==10) while(n<len-1 && (src[n+1]==32 || src[n+1]==9)) {
				n++;
				if (src[n]==9) dst[len1]=dst[len1+1]=9,len1+=2;
				else {
					for(t=1;n<len-1 && src[n+1]==32 && t<8;t++,n++);
					if (t==8) dst[len1]=dst[len1+1]=9,len1+=2;
					else if (n<len-1 && src[n+1]==9);
					else {
						if (t>=4) dst[len1++]=9,t-=4;
						for(;t>0;t--) dst[len1++]=32;
					}
				}
			}
		}
	}
	lseek(f,0,SEEK_SET);
	write(f,dst,len1); chsize(f,len1);
	free(src-1); free(dst-1); close(f);
	times.actime=buf.st_atime;
	times.modtime=buf.st_mtime;
	utime(name,&times);
	return 0;
}

int main(int argc,char *argv[]) {
	int mode=0,rv,mrv=0,i;
	struct dirent *thedir;
	if (argc<2 || !stricmp(argv[1],"-help") || !stricmp(argv[1],"--help")) {
		fprintf(stderr,"TabConv converts files with 8sp tabs to files with 4sp tabs\n");
		fprintf(stderr,"Usage: tabconv filename [f{orward}|b{ackward}]\n");
		return 1;
	}
	if (argc>=3 && toupper(*argv[2])=='B') mode=1;
	for(i=0;argv[1][i];i++) if (argv[1][i]=='?' || argv[1][i]=='*') {i=-2; break;}
	if (i>-1) return convert(argv[1],mode);
	else {
		thedir=opendir(argv[1]);
		if (thedir) {
			while(readdir(thedir)) {
				 rv=convert(thedir->d_name,mode);
				 mrv=(mrv==0) ? rv:(mrv!=rv)? mrv=10:mrv;
			}
			closedir(thedir);
		}
	}
	return mrv;
}
